<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="商机名称" prop="boName">
        <el-input
          v-model="queryParams.boName"
          placeholder="请输入商机名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="员工名称" prop="staffName">
        <el-input
          v-model="queryParams.staffName"
          placeholder="请输入员工名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="项目岗位" prop="post">
        <el-select v-model="queryParams.post" placeholder="请选择项目岗位">
          <el-option
            v-for="dict in dict.type.mk_bo_pojpsn_post"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="责任" prop="job">
        <el-select v-model="queryParams.job" placeholder="请选择责任">
          <el-option
            v-for="dict in dict.type.mk_bo_pojpsn_job"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <PojpsnList :key="timer" :source = "'Pojpsn'" :bo="queryParams" />
  </div>
</template>

<script>
import { listPojpsn, getPojpsn, delPojpsn, addPojpsn, updatePojpsn } from "@/api/business/spd/bo/pojpsn";
import StaffRef from '@/views/business/spd/bo/refer/staff/index.vue'
import PojpsnList from '../pojpsn/pojpsnList.vue'

export default {
  name: "Pojpsn",
  dicts: ['mk_bo_pojpsn_post','mk_bo_pojpsn_job'],
  components: {StaffRef,PojpsnList},
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 项目成员表格数据
      pojpsnList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        bo: null,
        boName: null,
        staff: null,
        staffName: null,
        post: null,
        job: null,
        tenantId: null,
        revision: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      //重新加载子组件参数
      timer: '',
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询项目成员列表 */
    getList() {
      this.loading = true;
      listPojpsn(this.queryParams).then(response => {
        this.pojpsnList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        bo: null,
        boName: null,
        staff: null,
        staffName: null,
        post: null,
        job: null,
        tenantId: null,
        revision: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        delFlag: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.timer = new Date().getTime();
      // this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加项目成员";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getPojpsn(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改项目成员";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updatePojpsn(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addPojpsn(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除项目成员编号为"' + ids + '"的数据项？').then(function() {
        return delPojpsn(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/pojpsn/export', {
        ...this.queryParams
      }, `pojpsn_${new Date().getTime()}.xlsx`)
    },
    // 触发员工参照列表
    refereStaff() {
      console.log('测试点击')
      this.$refs.contractSelect.init()
    },
    //员工参照列表选择后
    selectionsToInput (selections) {
      this.form.staff = selections[0].userId;
      this.form.staffName = selections[0].nickName;
    }
  }
};
</script>